﻿#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include<iostream>
#include<cmath>
#include <fstream>
#include <opencv2/opencv.hpp>
#include "RealSense2CV.h"
using namespace std;
using namespace cv;
string win_color = "color";
string win_depth = "depth";
string win_ifred = "ifred";

bool SavePointCloud(string filename, TRealSense2CV &realsense)
{
  vector<Point3d> p = realsense.depth2camera();
  ofstream ofs(filename);
  if (!ofs.is_open()) {
    cout << "ofs open failed" << endl;
    return false;
  }
  for (int i = 0; i < p.size(); i++) {
    ofs << p[i].x << " " << p[i].y << " " << p[i].z << endl;
  }
  ofs.flush();
  ofs.close();

  return true;
}

int main(int argc, char **argv)
{
  TRealSense2CV realsense;
  Mat img_color, img_depth, img_ifred;

  namedWindow(win_color, WINDOW_AUTOSIZE);
  namedWindow(win_depth, WINDOW_AUTOSIZE);
  namedWindow(win_ifred, WINDOW_AUTOSIZE);

  // RealSenseの初期化
  bool ret = realsense.init();
  if (!ret) {
    cout << "init error" << endl;
    return false;
  }

  while (true)
  {
    // キャプチャ
    bool ret = realsense.queryFrame();
    if (!ret) continue;

    // OpenCVのMat型に変換
    img_color = realsense.color();
    img_depth = realsense.depth();
    img_ifred = realsense.ifred();

    // 表示
    imshow(win_color, img_color);
    imshow(win_depth, img_depth);
    imshow(win_ifred, img_ifred);

    int key = waitKey(1);
    if (key == 'q') break;
    else if (key == 's') {
      imwrite("realsense_color.png", img_color);
      imwrite("realsense_depth.png", img_depth);
      imwrite("realsense_ifred.png", img_ifred);
      SavePointCloud("pointcloud.txt", realsense);
    }
  }

  return 0;
}